package com.agiledeveloper
import grails.converters.*

class TaskController {

    def list() {
      [tasks: Task.listOrderByName(), task: new Task()]
    }
    
    def create() {
      [task: new Task()]
    }
    
    def save() {
      def task = new Task(params)
      if(!task.save()) {
        render view: 'create', model: [task: task]
      }
      
      def tasks = Task.listOrderByName()
      def index = tasks.indexOf(task)
      def previousTaskId = index ? tasks[index - 1].id : -1
      
      def displayTask = g.render(template: 'displaytask', model: [task: task])
      
      def result = [previousTaskId: previousTaskId, task: displayTask] 
      render result as JSON
    }
    
    def delete(long id) {
      def task = Task.get(id)
      task.delete()
      redirect action: 'list'
    }
}
